#!/usr/bin/env python
#
# The purpose of this script it to retarget New bugs against the linux-meta
# package to the linux kernel package.

# TODO:
# * Convert script to generically move New bugs from one package to another

from arsenal_lib import *
#from lpltoolkit import LaunchpadService

arsenal = Arsenal()
distro = arsenal.load_project("ubuntu")
opt_dryrun = True

class BugTask():

    def transition(self, from_task, to_task, comment):
        old_task = distro.getSourcePackage(name=from_task)
        new_task = distro.getSourcePackage(name=to_task)
        collection = old_task.searchTasks()
        count = 1
        for bug_task in collection:
            bug = ArsenalBug(bug_task.bug, arsenal.launchpad)
            print count, " - ", bug.id, "  ", bug_task.status, "  ", bug.title
            count = count + 1
            skip = False

            if bug.has_tag("kj-linux-meta"):
                    print "Skipping, tagged kj-linux-meta"
                    continue

            # check if bug already has to_task open
            if len(bug_task.bug.bug_tasks) > 1:
                for task in bug_task.bug.bug_tasks:
                    if ("%s (Ubuntu)" % (to_task)) == task.bug_target_name:
                        print "Already assigned to %s" % (to_task)
                        skip = True
                        break

            if not skip:
                if opt_dryrun:
                    print "== Dry Run =="
                    print " --> Transition to ", new_task.name
                    print " --> Msg: ", comment
                else:
                    bug.append_comment(comment)
                    bug_task.transitionToTarget(target=new_task)

if __name__ == "__main__":

    comment = '''[This is an automated message.  Apologies if it has reached you inappropriately.]

This bug was reported against the linux-meta package when it likely should have been reported against the linux package instead.  We are automatically transitioning this to the linux kernel package so that the appropriate teams are notified and made aware of this issue.

If this bug really is a bug in the linux-meta package you can move it back to linux-meta and tag it kj-linux-meta, or contact us on the #ubuntu-kernel channel on the FreeNode IRC server.  Thanks.
'''

    bug_task = BugTask()
    bug_task.transition("linux-meta", "linux", comment)
    bug_task.transition("linux-meta-fsl-imx51", "linux-fsl-imx51", comment)
    bug_task.transition("linux-meta-mvl-dove", "linux-mvl-dove", comment)

# vi:set ts=4 sw=4 expandtab:
