#!/usr/bin/python

import simplejson as json
from arsenal_lib import *
from lpltoolkit import *

if len(sys.argv) < 3:
    die("Usage: " + sys.argv[0] + " <tag> <source-package>\n")

total_count = 0
tag         = sys.argv[1]
source_pkgs = sys.argv[2:]
lp          = LaunchpadService()
d           = lp.load_project("ubuntu")
records     = []

for source_pkg in source_pkgs:
    dbg("source:  %s\n" %(source_pkg))
    s = d.getSourcePackage(name = source_pkg)
    for bugtask in s.searchTasks(tags=tag):
        bug = ArsenalBug(bugtask.bug, lp.launchpad)
        bug.source_pkg = source_pkg

        records.append({
                'id'         : bug.id,
                '__url'      : "%s" %(bugtask.self),
                'title'      : bug.title,
                'package'    : source_pkg,
                'tags'       : bugtask.bug.tags,
                'status'     : numerical_status(bugtask.status),
                'importance' : numerical_importance(bugtask.importance),
                'gravity'    : bug.gravity()
                })

report = {
    'keys'      : [ 'id', 'title', 'importance', 'status', 'gravity' ],
    'bug_tasks' : records
}

print json.dumps(report, indent=4)

# TODO:  lazr.restfulclient.errors.HTTPError: HTTP Error 302: Found
